//+------------------------------------------------------------------+
//|                                               Alien stoch db.mq4 |
//|           0322-5524899             Copyright 2015, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#property indicator_chart_window

string _Comment_2 = "Preamble must be unique for evere instance in chart";
string objectpreamble = "alien_mini_db_";
 int UpdateTimerInSeconds = 5;
sinput ENUM_TIMEFRAMES  AlertTimeFrame    = PERIOD_H1; 
input string symbol ="EURUSD";
sinput long chartId = 0;
 int stoch_1_kPeriod = 8;
 int stoch_1_dPeriod = 3;
 int stoch_1_Slowing = 3;

 int stoch_2_kPeriod = 21;
 int stoch_2_dPeriod = 10;
 int stoch_2_Slowing = 10;
//sinput bool showMonth = false;
sinput bool showWeek = true;
sinput bool showDay = true;
sinput bool showH4 = true;
sinput bool showH1 = true;
sinput bool showM30 = false;
sinput bool showM15 = true;
sinput bool showM5 = true;
sinput bool showM1 = false;

//sinput bool show_stoch_1 = true;
 int kPeriod_1 = 8;
 int Slowing_1 = 3;
 int dPeriod_1 = 3;
 int maMethod_1 = 0;
 int priceField_1 = 1;

//sinput bool show_stoch_2 = true;
 int kPeriod_2 = 21;
 int Slowing_2 = 10;
 int dPeriod_2 = 10;
 int maMethod_2 = 0;
 int priceField_2 = 1;

//sinput bool show_stoch_3 = true;
 int kPeriod_3 = 100;
 int Slowing_3 = 10;
 int dPeriod_3 = 10;
 int maMethod_3 = 0;
 int priceField_3 = 1;


sinput int xAnchor = 500;
sinput int yAnchor = 10;
sinput int fontSizeText = 6;
sinput int smallPanelWidth = 40;
sinput int smallPanelheight = 18;
sinput int smallPanelSpace = 5;
sinput int textOffsetY = 3;
input int rowHeight                 = 20;

int panelWidth_1 = 75;
int panelHeight_1 = rowHeight;
int borderWidth_1 = 1;
int textOffset_1 = 1;
int fontSize_1 = 9;

int widthColumn_2 = 40;
int offsetColumn_2 = panelWidth_1;
int widthColumn_3 = 40;
int offsetColumn_3 = offsetColumn_2 + widthColumn_2 + 2;
int widthColumn_4 = 40;
int offsetColumn_4 = offsetColumn_3 + widthColumn_3 + 2;

int widthColumn_5 = 98;
int offsetColumn_5 = offsetColumn_4 + widthColumn_4 + 12;

sinput color textColor = clrWhite;
sinput color dbBackgroundColor = clrBlack;
sinput color dbBorderColor = clrGainsboro;
sinput int dbBorderWidth = 1;

sinput color bullColor = clrLime;
sinput color bearColor = clrRed;
sinput color flatColor = DimGray;;
extern color colorWeakUpTrend = DodgerBlue;
extern color colorWeakDownTrend = DarkOrange;


double stochUpperlevel = 80.0;
double stochLowerlevel = 20.0;
double stochMiddellevel = 50.0;

enum RSIOMA_ENUM {
	RSIOMA_UP = 3,			
	RSIOMA_DOWN = -3,
	RSIOMA_NEUTRAL = 0,
	RSIOMA_ABOVE_80 = 2,
	RSIOMA_ABOVE_50 = 1,
	RSIOMA_BELOW_50 = -1,
	RSIOMA_BELOW_20 = -2		
};

int yOffsetArrow;

string preamble ;
int panelWidth;
int panelHeight;
bool showPips = true;

string panelName, labelName;
string strButton;

string strSupport;
string strResistance;

double supp, ress, supp_c, ress_c;
double myPoint, myDigits, myMultiplier;

static datetime updateRS;


double tmpValue_1, tmpValue_2, tmpValue_3, tmpValue_4, tmpValue_5, tmpValue_6, tmpValue_7, tmpValue_8, tmpValue_9, tmpValue_10;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   
//---
   preamble = objectpreamble;
   string name, s;
   s = objectpreamble;
    for (int i = ObjectsTotal() - 1; i >= 0; i--)
    {
        name = ObjectName(i);
        if (StringSubstr(name, 0, StringLen(s)) == s)
        {
            ObjectDelete(name);
        }
    }
   EventSetTimer(UpdateTimerInSeconds);
   
   int counter = 0;
   
   if (showM1) {counter++;}
   if (showM5) {counter++;}
   if (showM15) {counter++;}
   if (showM30) {counter++;}
   if (showH1) {counter++;}
   if (showH4) {counter++;}
   if (showDay) {counter++;}
   if (showWeek) {counter++;}
   
   if (counter == 0)
   {
      Alert("No TF selected");
      return(INIT_FAILED);
   }
   panelHeight = (counter + 2) * smallPanelheight + (counter + 3) * smallPanelSpace;
   panelWidth = fontSizeText * 3 + 4 * (smallPanelWidth + smallPanelSpace);
   
 
   
   myDigits = MarketInfo(symbol,MODE_DIGITS);
   myPoint = MarketInfo(symbol,MODE_POINT);
   if( myDigits == 3 || myDigits == 5 ) myPoint = myPoint * 10;
   myMultiplier = 1.0 / myPoint;
   
   updateRS = 0;
   return(INIT_SUCCEEDED);
   
  }
  
void OnDeinit(const int reason)
  {
//--- destroy timer
   EventKillTimer();
   
   // delete objects
    string name;
    string s = preamble;
 
    for (int i = ObjectsTotal() - 1; i >= 0; i--)
    {
        name = ObjectName(i);
        if (StringSubstr(name, 0, StringLen(s)) == s)
        {
            ObjectDelete(name);
        }
    }
      
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
  {
//---
   // calculate the rsioma values for all selected timeframes
   
   int xOffset = xAnchor;
   int yOffset = yAnchor;
   int stochOffset = 35;
   int pips;

   //int _squareSize = squareSize - 2;
   
   
   if (updateRS != iTime(symbol, PERIOD_M5,0))
   {
      updateRS = iTime(symbol, PERIOD_M5,0);
        }
   
   //first display panel
   
   // headers
   SetPanel(preamble + "panel_"+symbol,chartId,xOffset, yOffset, panelWidth+70, panelHeight,dbBackgroundColor,dbBorderColor,dbBorderWidth);
   
   if (true)
   {
      SetText(chartId, preamble + "header_1"+symbol, symbol, xOffset + stochOffset, yOffset + fontSizeText, textColor, 10);
      yOffset = yOffset + smallPanelheight;
      SetText(chartId, preamble + "header_1_8"+symbol, "    7", xOffset + stochOffset, yOffset + fontSizeText, textColor, fontSizeText);
      SetText(chartId, preamble + "header_1_21"+symbol, "    21", xOffset + stochOffset + smallPanelWidth + smallPanelSpace, yOffset + fontSizeText, textColor, fontSizeText);
      SetText(chartId, preamble + "header_1_100"+symbol, "    42", xOffset + stochOffset + 2*smallPanelWidth + 2*smallPanelSpace, yOffset + fontSizeText, textColor, fontSizeText);
      SetText(chartId, preamble + "header_1_101"+symbol, "    89", xOffset + stochOffset + 3*smallPanelWidth + 3*smallPanelSpace, yOffset + fontSizeText, textColor, fontSizeText);
      SetText(chartId, preamble + "header_1_102"+symbol, "    144", xOffset + stochOffset + 4*smallPanelWidth + 4*smallPanelSpace, yOffset + fontSizeText, textColor, fontSizeText);
  
   }
   if (showM1)
   {
       // write TF
      yOffset = yOffset + smallPanelheight + smallPanelSpace;
      SetText(chartId,preamble + "labelText_M1_1"+symbol, "      M1", xAnchor + smallPanelSpace, yOffset + textOffsetY,textColor,fontSizeText);
      
      double val1 = iADX(symbol,PERIOD_M1,7, PRICE_CLOSE, MODE_MAIN, 0);
      double val2 = iADX(symbol,PERIOD_M1,7, PRICE_CLOSE, MODE_MAIN,  1);
      double dmip = iADX(symbol,PERIOD_M1,7, PRICE_CLOSE, MODE_PLUSDI, 0);
      double dmim = iADX(symbol,PERIOD_M1,7, PRICE_CLOSE, MODE_MINUSDI, 0);
            
      panelName = preamble + "panel_M1_1_" + symbol;
      SetPanel(panelName,chartId, xOffset + stochOffset, yOffset, smallPanelWidth, smallPanelheight,dbBackgroundColor, dbBorderColor, dbBorderWidth);

      labelName = preamble + "label_M1_1_" + symbol;
    
     int fontSizeTest = 14;
     int offsetSquare = -3;
      
     if ((val1 > val2 ) && (dmip > dmim))
      { 
      SetPanel(panelName,chartId, xOffset + stochOffset, yOffset, smallPanelWidth, smallPanelheight,bullColor, dbBorderColor, dbBorderWidth);
      }
      
      else if ((val1 > val2 ) && (dmip < dmim) )
      {
              SetPanel(panelName,chartId, xOffset + stochOffset, yOffset, smallPanelWidth, smallPanelheight,bearColor, dbBorderColor, dbBorderWidth);
      }
      else
      {
         SetPanel(panelName,chartId, xOffset + stochOffset, yOffset, smallPanelWidth, smallPanelheight,flatColor, dbBorderColor, dbBorderWidth);
      }
      
      double val3 = iADX(symbol,PERIOD_M1,21, PRICE_CLOSE, MODE_MAIN, 0);
      double val4 = iADX(symbol,PERIOD_M1,21, PRICE_CLOSE, MODE_MAIN,  1);
      double dmip1 = iADX(symbol,PERIOD_M1,21, PRICE_CLOSE, MODE_PLUSDI, 0);
      double dmim1 = iADX(symbol,PERIOD_M1,21, PRICE_CLOSE, MODE_MINUSDI, 0);
      
      panelName = preamble + "panel_M1_2_" + symbol;
      SetPanel(panelName,chartId, xOffset + stochOffset + smallPanelWidth + smallPanelSpace, yOffset, smallPanelWidth, smallPanelheight,dbBackgroundColor, dbBorderColor, dbBorderWidth);
      labelName = preamble + "label_M1_2_" + symbol;
   
      if ((val3 > val4 ) && (dmip1 > dmim1))
      { 
          SetPanel(panelName,chartId, xOffset + stochOffset + smallPanelWidth + smallPanelSpace, yOffset, smallPanelWidth, smallPanelheight,bullColor, dbBorderColor, dbBorderWidth);
       }
      else if ((val3 > val4 ) && (dmip1 < dmim1) )
      {
           SetPanel(panelName,chartId, xOffset + stochOffset + smallPanelWidth + smallPanelSpace, yOffset, smallPanelWidth, smallPanelheight,bearColor, dbBorderColor, dbBorderWidth);
      }
      else
      {
           SetPanel(panelName,chartId, xOffset + stochOffset + smallPanelWidth + smallPanelSpace, yOffset, smallPanelWidth, smallPanelheight,flatColor, dbBorderColor, dbBorderWidth);
      }
      
      double val5 = iADX(symbol,PERIOD_M1,42, PRICE_CLOSE, MODE_MAIN, 0);
      double val6 = iADX(symbol,PERIOD_M1,42, PRICE_CLOSE, MODE_MAIN,  1);
      double dmip2 = iADX(symbol,PERIOD_M1,42, PRICE_CLOSE, MODE_PLUSDI, 0);
      double dmim2 = iADX(symbol,PERIOD_M1,42, PRICE_CLOSE, MODE_MINUSDI, 0);
      
      panelName = preamble + "panel_M1_3_" + symbol;
      SetPanel(panelName,chartId, xOffset + stochOffset + 2 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,dbBackgroundColor, dbBorderColor, dbBorderWidth);
      labelName = preamble + "label_M1_3_" + symbol;
    
     if ((val5 > val6 ) && (dmip2 > dmim2))
      { 
        SetPanel(panelName,chartId, xOffset + stochOffset + 2 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bullColor, dbBorderColor, dbBorderWidth);
      }
      
      else if ((val5 > val6 ) && (dmip2 < dmim2) )
      {
            SetPanel(panelName,chartId, xOffset + stochOffset + 2 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bearColor, dbBorderColor, dbBorderWidth);
      }
     
      else
      {
              SetPanel(panelName,chartId, xOffset + stochOffset + 2 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,flatColor, dbBorderColor, dbBorderWidth);
       }
      
      double val7 = iADX(symbol,PERIOD_M1,89, PRICE_CLOSE, MODE_MAIN, 0);
      double val8 = iADX(symbol,PERIOD_M1,89, PRICE_CLOSE, MODE_MAIN,  1);
      double dmip3 = iADX(symbol,PERIOD_M1,89, PRICE_CLOSE, MODE_PLUSDI, 0);
      double dmim3 = iADX(symbol,PERIOD_M1,89, PRICE_CLOSE, MODE_MINUSDI, 0);
      
      panelName = preamble + "panel_M1_1_" + symbol;
      SetPanel(panelName,chartId, xOffset + stochOffset + 3 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,dbBackgroundColor, dbBorderColor, dbBorderWidth);
      labelName = preamble + "label_M1_1_" + symbol;
      
     if ((val7 > val8 ) && (dmip3 > dmim3))
      { 
        SetPanel(panelName,chartId, xOffset + stochOffset + 3 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bullColor, dbBorderColor, dbBorderWidth);
     }
      
      else if ((val7 > val8 ) && (dmip3 < dmim3) )
      {
             SetPanel(panelName,chartId, xOffset + stochOffset + 3 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bearColor, dbBorderColor, dbBorderWidth);
       }
     
      else
      {
           SetPanel(panelName,chartId, xOffset + stochOffset + 3 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,flatColor, dbBorderColor, dbBorderWidth);
      }
      
      double val9 = iADX(symbol,PERIOD_M1,144, PRICE_CLOSE, MODE_MAIN, 0);
      double val10 = iADX(symbol,PERIOD_M1,144, PRICE_CLOSE, MODE_MAIN,  1);
      double dmip4 = iADX(symbol,PERIOD_M1,144, PRICE_CLOSE, MODE_PLUSDI, 0);
      double dmim4 = iADX(symbol,PERIOD_M1,144, PRICE_CLOSE, MODE_MINUSDI, 0);
      
      panelName = preamble + "panel_M1_dds_" + symbol;
      SetPanel(panelName,chartId, xOffset + stochOffset + 4 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,dbBackgroundColor, dbBorderColor, dbBorderWidth);
      labelName = preamble + "label_M1_dds_" + symbol;
      
     if ((val9 > val10 ) && (dmip4 > dmim4))
      { 
            SetPanel(panelName,chartId, xOffset + stochOffset + 4 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bullColor, dbBorderColor, dbBorderWidth);
      }
      
      else if ((val9 > val10 ) && (dmip4 < dmim4) )
      {
        SetPanel(panelName,chartId, xOffset + stochOffset + 4 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bearColor, dbBorderColor, dbBorderWidth);
      }
     
      
      else
      {
           SetPanel(panelName,chartId, xOffset + stochOffset + 4 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,flatColor, dbBorderColor, dbBorderWidth);
       }
    
      ////////////************** Alert Function
           if ((val1 > val2 ) && (dmip > dmim) && (val3 > val4 ) && (dmip1 > dmim1) && (val5 > val6 ) && (dmip2 > dmim2) && (val7 > val8 ) && (dmip3 > dmim3) && (val9 > val10 ) && (dmip4 > dmim4) && (AlertTimeFrame==PERIOD_M1))
            {
            doAlert("All ADX Lime On  " + AlertTimeFrame);
            }
      
      //// End Alert 
    
               //************************************** end now *******************************************
     
    
   
   }
   
   if (showM5)
   {
      // write TF
      yOffset = yOffset + smallPanelheight + smallPanelSpace;
      SetText(chartId,preamble + "labelText_M5_1"+symbol, "      M5", xAnchor + smallPanelSpace, yOffset + textOffsetY,textColor,fontSizeText);
      
      double val1 = iADX(symbol,PERIOD_M5,7, PRICE_CLOSE, MODE_MAIN, 0);
      double val2 = iADX(symbol,PERIOD_M5,7, PRICE_CLOSE, MODE_MAIN,  1);
      double dmip = iADX(symbol,PERIOD_M5,7, PRICE_CLOSE, MODE_PLUSDI, 0);
      double dmim = iADX(symbol,PERIOD_M5,7, PRICE_CLOSE, MODE_MINUSDI, 0);
            
      panelName = preamble + "panel_M5_1_" + symbol;
      SetPanel(panelName,chartId, xOffset + stochOffset, yOffset, smallPanelWidth, smallPanelheight,dbBackgroundColor, dbBorderColor, dbBorderWidth);

      labelName = preamble + "label_M5_1_" + symbol;
    
     int fontSizeTest = 14;
     int offsetSquare = -3;
      
     if ((val1 > val2 ) && (dmip > dmim))
      { 
      SetPanel(panelName,chartId, xOffset + stochOffset, yOffset, smallPanelWidth, smallPanelheight,bullColor, dbBorderColor, dbBorderWidth);
      }
      
      else if ((val1 > val2 ) && (dmip < dmim) )
      {
              SetPanel(panelName,chartId, xOffset + stochOffset, yOffset, smallPanelWidth, smallPanelheight,bearColor, dbBorderColor, dbBorderWidth);
      }
      else
      {
         SetPanel(panelName,chartId, xOffset + stochOffset, yOffset, smallPanelWidth, smallPanelheight,flatColor, dbBorderColor, dbBorderWidth);
      }
      
      double val3 = iADX(symbol,PERIOD_M5,21, PRICE_CLOSE, MODE_MAIN, 0);
      double val4 = iADX(symbol,PERIOD_M5,21, PRICE_CLOSE, MODE_MAIN,  1);
      double dmip1 = iADX(symbol,PERIOD_M5,21, PRICE_CLOSE, MODE_PLUSDI, 0);
      double dmim1 = iADX(symbol,PERIOD_M5,21, PRICE_CLOSE, MODE_MINUSDI, 0);
      
      panelName = preamble + "panel_M5_2_" + symbol;
      SetPanel(panelName,chartId, xOffset + stochOffset + smallPanelWidth + smallPanelSpace, yOffset, smallPanelWidth, smallPanelheight,dbBackgroundColor, dbBorderColor, dbBorderWidth);
      labelName = preamble + "label_M5_2_" + symbol;
   
      if ((val3 > val4 ) && (dmip1 > dmim1))
      { 
          SetPanel(panelName,chartId, xOffset + stochOffset + smallPanelWidth + smallPanelSpace, yOffset, smallPanelWidth, smallPanelheight,bullColor, dbBorderColor, dbBorderWidth);
       }
      else if ((val3 > val4 ) && (dmip1 < dmim1) )
      {
           SetPanel(panelName,chartId, xOffset + stochOffset + smallPanelWidth + smallPanelSpace, yOffset, smallPanelWidth, smallPanelheight,bearColor, dbBorderColor, dbBorderWidth);
      }
      else
      {
           SetPanel(panelName,chartId, xOffset + stochOffset + smallPanelWidth + smallPanelSpace, yOffset, smallPanelWidth, smallPanelheight,flatColor, dbBorderColor, dbBorderWidth);
      }
      
      double val5 = iADX(symbol,PERIOD_M5,42, PRICE_CLOSE, MODE_MAIN, 0);
      double val6 = iADX(symbol,PERIOD_M5,42, PRICE_CLOSE, MODE_MAIN,  1);
      double dmip2 = iADX(symbol,PERIOD_M5,42, PRICE_CLOSE, MODE_PLUSDI, 0);
      double dmim2 = iADX(symbol,PERIOD_M5,42, PRICE_CLOSE, MODE_MINUSDI, 0);
      
      panelName = preamble + "panel_M5_3_" + symbol;
      SetPanel(panelName,chartId, xOffset + stochOffset + 2 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,dbBackgroundColor, dbBorderColor, dbBorderWidth);
      labelName = preamble + "label_M5_3_" + symbol;
    
     if ((val5 > val6 ) && (dmip2 > dmim2))
      { 
        SetPanel(panelName,chartId, xOffset + stochOffset + 2 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bullColor, dbBorderColor, dbBorderWidth);
      }
      
      else if ((val5 > val6 ) && (dmip2 < dmim2) )
      {
            SetPanel(panelName,chartId, xOffset + stochOffset + 2 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bearColor, dbBorderColor, dbBorderWidth);
      }
     
      else
      {
              SetPanel(panelName,chartId, xOffset + stochOffset + 2 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,flatColor, dbBorderColor, dbBorderWidth);
       }
      
      double val7 = iADX(symbol,PERIOD_M5,89, PRICE_CLOSE, MODE_MAIN, 0);
      double val8 = iADX(symbol,PERIOD_M5,89, PRICE_CLOSE, MODE_MAIN,  1);
      double dmip3 = iADX(symbol,PERIOD_M5,89, PRICE_CLOSE, MODE_PLUSDI, 0);
      double dmim3 = iADX(symbol,PERIOD_M5,89, PRICE_CLOSE, MODE_MINUSDI, 0);
      
      panelName = preamble + "panel_M1_5_" + symbol;
      SetPanel(panelName,chartId, xOffset + stochOffset + 3 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,dbBackgroundColor, dbBorderColor, dbBorderWidth);
      labelName = preamble + "label_M1_5_" + symbol;
      
     if ((val7 > val8 ) && (dmip3 > dmim3))
      { 
        SetPanel(panelName,chartId, xOffset + stochOffset + 3 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bullColor, dbBorderColor, dbBorderWidth);
     }
      
      else if ((val7 > val8 ) && (dmip3 < dmim3) )
      {
             SetPanel(panelName,chartId, xOffset + stochOffset + 3 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bearColor, dbBorderColor, dbBorderWidth);
       }
     
      else
      {
           SetPanel(panelName,chartId, xOffset + stochOffset + 3 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,flatColor, dbBorderColor, dbBorderWidth);
      }
      
    
          
     //
    
      // dds
      double val9 = iADX(symbol,PERIOD_M5,144, PRICE_CLOSE, MODE_MAIN, 0);
      double val10 = iADX(symbol,PERIOD_M5,144, PRICE_CLOSE, MODE_MAIN,  1);
      double dmip4 = iADX(symbol,PERIOD_M5,144, PRICE_CLOSE, MODE_PLUSDI, 0);
      double dmim4 = iADX(symbol,PERIOD_M5,144, PRICE_CLOSE, MODE_MINUSDI, 0);
      
      panelName = preamble + "panel_M5_dds_" + symbol;
      SetPanel(panelName,chartId, xOffset + stochOffset + 4 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,dbBackgroundColor, dbBorderColor, dbBorderWidth);
      labelName = preamble + "label_M5_dds_" + symbol;
      
     if ((val9 > val10 ) && (dmip4 > dmim4))
      { 
            SetPanel(panelName,chartId, xOffset + stochOffset + 4 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bullColor, dbBorderColor, dbBorderWidth);
      }
      
      else if ((val9 > val10 ) && (dmip4 < dmim4) )
      {
        SetPanel(panelName,chartId, xOffset + stochOffset + 4 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bearColor, dbBorderColor, dbBorderWidth);
      }
     
      
      else
      {
           SetPanel(panelName,chartId, xOffset + stochOffset + 4 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,flatColor, dbBorderColor, dbBorderWidth);
       }
    
      ////////////************** Alert Function
           if ((val1 > val2 ) && (dmip > dmim) && (val3 > val4 ) && (dmip1 > dmim1) && (val5 > val6 ) && (dmip2 > dmim2) && (val7 > val8 ) && (dmip3 > dmim3) && (val9 > val10 ) && (dmip4 > dmim4) && (AlertTimeFrame==PERIOD_M5))
            {
            doAlert( symbol +" All ADX Lime On  " + AlertTimeFrame);
            }
      
            else if ((val1 > val2 ) && (dmip < dmim) && (val3 > val4 ) && (dmip1 < dmim1) && (val5 > val6 ) && (dmip2 < dmim2)&& (val7 > val8 ) && (dmip3 < dmim3) &&(val9 > val10 ) && (dmip4 < dmim4) && (AlertTimeFrame==PERIOD_M5) )
            {
              doAlert( symbol +" All ADX Red On  " + AlertTimeFrame);
            }
      
      //// End Alert 
    
    
               //************************************** end now *******************************************
      
   }
   
   if (showM15)
   {
  
      yOffset = yOffset + smallPanelheight + smallPanelSpace;
      SetText(chartId,preamble + "labelText_M15_1"+symbol, "      M15", xAnchor + smallPanelSpace, yOffset + textOffsetY,textColor,fontSizeText);
      
      double val1 = iADX(symbol,PERIOD_M15,7, PRICE_CLOSE, MODE_MAIN, 0);
      double val2 = iADX(symbol,PERIOD_M15,7, PRICE_CLOSE, MODE_MAIN,  1);
      double dmip = iADX(symbol,PERIOD_M15,7, PRICE_CLOSE, MODE_PLUSDI, 0);
      double dmim = iADX(symbol,PERIOD_M15,7, PRICE_CLOSE, MODE_MINUSDI, 0);
            
      panelName = preamble + "panel_M15_1_" + symbol;
      SetPanel(panelName,chartId, xOffset + stochOffset, yOffset, smallPanelWidth, smallPanelheight,dbBackgroundColor, dbBorderColor, dbBorderWidth);

      labelName = preamble + "label_M15_1_" + symbol;
    
     int fontSizeTest = 14;
     int offsetSquare = -3;
      
     if ((val1 > val2 ) && (dmip > dmim))
      { 
      SetPanel(panelName,chartId, xOffset + stochOffset, yOffset, smallPanelWidth, smallPanelheight,bullColor, dbBorderColor, dbBorderWidth);
      }
      
      else if ((val1 > val2 ) && (dmip < dmim) )
      {
              SetPanel(panelName,chartId, xOffset + stochOffset, yOffset, smallPanelWidth, smallPanelheight,bearColor, dbBorderColor, dbBorderWidth);
      }
      else
      {
         SetPanel(panelName,chartId, xOffset + stochOffset, yOffset, smallPanelWidth, smallPanelheight,flatColor, dbBorderColor, dbBorderWidth);
      }
  
     double val3 = iADX(symbol,PERIOD_M15,21, PRICE_CLOSE, MODE_MAIN, 0);
      double val4 = iADX(symbol,PERIOD_M15,21, PRICE_CLOSE, MODE_MAIN,  1);
      double dmip1 = iADX(symbol,PERIOD_M15,21, PRICE_CLOSE, MODE_PLUSDI, 0);
      double dmim1 = iADX(symbol,PERIOD_M15,21, PRICE_CLOSE, MODE_MINUSDI, 0);
      
      panelName = preamble + "panel_M15_2_" + symbol;
      SetPanel(panelName,chartId, xOffset + stochOffset + smallPanelWidth + smallPanelSpace, yOffset, smallPanelWidth, smallPanelheight,dbBackgroundColor, dbBorderColor, dbBorderWidth);
      labelName = preamble + "label_M15_2_" + symbol;
   
      if ((val3 > val4 ) && (dmip1 > dmim1))
      { 
          SetPanel(panelName,chartId, xOffset + stochOffset + smallPanelWidth + smallPanelSpace, yOffset, smallPanelWidth, smallPanelheight,bullColor, dbBorderColor, dbBorderWidth);
       }
      else if ((val3 > val4 ) && (dmip1 < dmim1) )
      {
           SetPanel(panelName,chartId, xOffset + stochOffset + smallPanelWidth + smallPanelSpace, yOffset, smallPanelWidth, smallPanelheight,bearColor, dbBorderColor, dbBorderWidth);
      }
      else
      {
           SetPanel(panelName,chartId, xOffset + stochOffset + smallPanelWidth + smallPanelSpace, yOffset, smallPanelWidth, smallPanelheight,flatColor, dbBorderColor, dbBorderWidth);
      }
      
      double val5 = iADX(symbol,PERIOD_M15,42, PRICE_CLOSE, MODE_MAIN, 0);
      double val6 = iADX(symbol,PERIOD_M15,42, PRICE_CLOSE, MODE_MAIN,  1);
      double dmip2 = iADX(symbol,PERIOD_M15,42, PRICE_CLOSE, MODE_PLUSDI, 0);
      double dmim2 = iADX(symbol,PERIOD_M15,42, PRICE_CLOSE, MODE_MINUSDI, 0);
      
      panelName = preamble + "panel_M15_3_" + symbol;
      SetPanel(panelName,chartId, xOffset + stochOffset + 2 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,dbBackgroundColor, dbBorderColor, dbBorderWidth);
      labelName = preamble + "label_M15_3_" + symbol;
    
     if ((val5 > val6 ) && (dmip2 > dmim2))
      { 
        SetPanel(panelName,chartId, xOffset + stochOffset + 2 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bullColor, dbBorderColor, dbBorderWidth);
      }
      
      else if ((val5 > val6 ) && (dmip2 < dmim2) )
      {
            SetPanel(panelName,chartId, xOffset + stochOffset + 2 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bearColor, dbBorderColor, dbBorderWidth);
      }
     
      else
      {
              SetPanel(panelName,chartId, xOffset + stochOffset + 2 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,flatColor, dbBorderColor, dbBorderWidth);
       }
      
      double val7 = iADX(symbol,PERIOD_M15,89, PRICE_CLOSE, MODE_MAIN, 0);
      double val8 = iADX(symbol,PERIOD_M15,89, PRICE_CLOSE, MODE_MAIN,  1);
      double dmip3 = iADX(symbol,PERIOD_M15,89, PRICE_CLOSE, MODE_PLUSDI, 0);
      double dmim3 = iADX(symbol,PERIOD_M15,89, PRICE_CLOSE, MODE_MINUSDI, 0);
      
      panelName = preamble + "panel_M1_15_" + symbol;
      SetPanel(panelName,chartId, xOffset + stochOffset + 3 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,dbBackgroundColor, dbBorderColor, dbBorderWidth);
      labelName = preamble + "label_M1_15_" + symbol;
      
     if ((val7 > val8 ) && (dmip3 > dmim3))
      { 
        SetPanel(panelName,chartId, xOffset + stochOffset + 3 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bullColor, dbBorderColor, dbBorderWidth);
     }
      
      else if ((val7 > val8 ) && (dmip3 < dmim3) )
      {
             SetPanel(panelName,chartId, xOffset + stochOffset + 3 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bearColor, dbBorderColor, dbBorderWidth);
       }
     
      else
      {
           SetPanel(panelName,chartId, xOffset + stochOffset + 3 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,flatColor, dbBorderColor, dbBorderWidth);
      }
    
      double val9 = iADX(symbol,PERIOD_M15,144, PRICE_CLOSE, MODE_MAIN, 0);
      double val10 = iADX(symbol,PERIOD_M15,144, PRICE_CLOSE, MODE_MAIN,  1);
      double dmip4 = iADX(symbol,PERIOD_M15,144, PRICE_CLOSE, MODE_PLUSDI, 0);
      double dmim4 = iADX(symbol,PERIOD_M15,144, PRICE_CLOSE, MODE_MINUSDI, 0);
      
      panelName = preamble + "panel_M15_dds_" + symbol;
      SetPanel(panelName,chartId, xOffset + stochOffset + 4 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,dbBackgroundColor, dbBorderColor, dbBorderWidth);
      labelName = preamble + "label_M15_dds_" + symbol;
      
     if ((val9 > val10 ) && (dmip4 > dmim4))
      { 
            SetPanel(panelName,chartId, xOffset + stochOffset + 4 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bullColor, dbBorderColor, dbBorderWidth);
      }
      
      else if ((val9 > val10 ) && (dmip4 < dmim4) )
      {
        SetPanel(panelName,chartId, xOffset + stochOffset + 4 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bearColor, dbBorderColor, dbBorderWidth);
      }
        
      else
      {
           SetPanel(panelName,chartId, xOffset + stochOffset + 4 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,flatColor, dbBorderColor, dbBorderWidth);
       }
       
       ////////////************** Alert Function
           if ((val1 > val2 ) && (dmip > dmim) && (val3 > val4 ) && (dmip1 > dmim1) && (val5 > val6 ) && (dmip2 > dmim2) && (val7 > val8 ) && (dmip3 > dmim3) && (val9 > val10 ) && (dmip4 > dmim4) && (AlertTimeFrame==PERIOD_M15))
            {
            doAlert( symbol +" All ADX Lime On  " + AlertTimeFrame);
            }
      
            else if ((val1 > val2 ) && (dmip < dmim) && (val3 > val4 ) && (dmip1 < dmim1) && (val5 > val6 ) && (dmip2 < dmim2)&& (val7 > val8 ) && (dmip3 < dmim3) &&(val9 > val10 ) && (dmip4 < dmim4) && (AlertTimeFrame==PERIOD_M15) )
            {
              doAlert( symbol +" All ADX Red On  " + AlertTimeFrame);
            }
      
      //// End Alert 
    
    
               //************************************** end now *******************************************
          
   }
   
   if (showM30)
   {
      yOffset = yOffset + smallPanelheight + smallPanelSpace;
      SetText(chartId,preamble + "labelText_M30_1"+symbol, "      M30", xAnchor + smallPanelSpace, yOffset + textOffsetY,textColor,fontSizeText);
      
      double val1 = iADX(symbol,PERIOD_M30,7, PRICE_CLOSE, MODE_MAIN, 0);
      double val2 = iADX(symbol,PERIOD_M30,7, PRICE_CLOSE, MODE_MAIN,  1);
      double dmip = iADX(symbol,PERIOD_M30,7, PRICE_CLOSE, MODE_PLUSDI, 0);
      double dmim = iADX(symbol,PERIOD_M30,7, PRICE_CLOSE, MODE_MINUSDI, 0);
            
      panelName = preamble + "panel_M30_1_" + symbol;
      SetPanel(panelName,chartId, xOffset + stochOffset, yOffset, smallPanelWidth, smallPanelheight,dbBackgroundColor, dbBorderColor, dbBorderWidth);

      labelName = preamble + "label_M30_1_" + symbol;
    
     int fontSizeTest = 14;
     int offsetSquare = -3;
      
     if ((val1 > val2 ) && (dmip > dmim))
      { 
      SetPanel(panelName,chartId, xOffset + stochOffset, yOffset, smallPanelWidth, smallPanelheight,bullColor, dbBorderColor, dbBorderWidth);
      }
      
      else if ((val1 > val2 ) && (dmip < dmim) )
      {
              SetPanel(panelName,chartId, xOffset + stochOffset, yOffset, smallPanelWidth, smallPanelheight,bearColor, dbBorderColor, dbBorderWidth);
      }
      else
      {
         SetPanel(panelName,chartId, xOffset + stochOffset, yOffset, smallPanelWidth, smallPanelheight,flatColor, dbBorderColor, dbBorderWidth);
      }
  
     double val3 = iADX(symbol,PERIOD_M30,21, PRICE_CLOSE, MODE_MAIN, 0);
      double val4 = iADX(symbol,PERIOD_M30,21, PRICE_CLOSE, MODE_MAIN,  1);
      double dmip1 = iADX(symbol,PERIOD_M30,21, PRICE_CLOSE, MODE_PLUSDI, 0);
      double dmim1 = iADX(symbol,PERIOD_M30,21, PRICE_CLOSE, MODE_MINUSDI, 0);
      
      panelName = preamble + "panel_M30_2_" + symbol;
      SetPanel(panelName,chartId, xOffset + stochOffset + smallPanelWidth + smallPanelSpace, yOffset, smallPanelWidth, smallPanelheight,dbBackgroundColor, dbBorderColor, dbBorderWidth);
      labelName = preamble + "label_M30_2_" + symbol;
   
      if ((val3 > val4 ) && (dmip1 > dmim1))
      { 
          SetPanel(panelName,chartId, xOffset + stochOffset + smallPanelWidth + smallPanelSpace, yOffset, smallPanelWidth, smallPanelheight,bullColor, dbBorderColor, dbBorderWidth);
       }
      else if ((val3 > val4 ) && (dmip1 < dmim1) )
      {
           SetPanel(panelName,chartId, xOffset + stochOffset + smallPanelWidth + smallPanelSpace, yOffset, smallPanelWidth, smallPanelheight,bearColor, dbBorderColor, dbBorderWidth);
      }
      else
      {
           SetPanel(panelName,chartId, xOffset + stochOffset + smallPanelWidth + smallPanelSpace, yOffset, smallPanelWidth, smallPanelheight,flatColor, dbBorderColor, dbBorderWidth);
      }
      
      double val5 = iADX(symbol,PERIOD_M30,42, PRICE_CLOSE, MODE_MAIN, 0);
      double val6 = iADX(symbol,PERIOD_M30,42, PRICE_CLOSE, MODE_MAIN,  1);
      double dmip2 = iADX(symbol,PERIOD_M30,42, PRICE_CLOSE, MODE_PLUSDI, 0);
      double dmim2 = iADX(symbol,PERIOD_M30,42, PRICE_CLOSE, MODE_MINUSDI, 0);
      
      panelName = preamble + "panel_M30_3_" + symbol;
      SetPanel(panelName,chartId, xOffset + stochOffset + 2 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,dbBackgroundColor, dbBorderColor, dbBorderWidth);
      labelName = preamble + "label_M30_3_" + symbol;
    
     if ((val5 > val6 ) && (dmip2 > dmim2))
      { 
        SetPanel(panelName,chartId, xOffset + stochOffset + 2 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bullColor, dbBorderColor, dbBorderWidth);
      }
      
      else if ((val5 > val6 ) && (dmip2 < dmim2) )
      {
            SetPanel(panelName,chartId, xOffset + stochOffset + 2 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bearColor, dbBorderColor, dbBorderWidth);
      }
     
      else
      {
              SetPanel(panelName,chartId, xOffset + stochOffset + 2 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,flatColor, dbBorderColor, dbBorderWidth);
       }
      
      double val7 = iADX(symbol,PERIOD_M30,89, PRICE_CLOSE, MODE_MAIN, 0);
      double val8 = iADX(symbol,PERIOD_M30,89, PRICE_CLOSE, MODE_MAIN,  1);
      double dmip3 = iADX(symbol,PERIOD_M30,89, PRICE_CLOSE, MODE_PLUSDI, 0);
      double dmim3 = iADX(symbol,PERIOD_M30,89, PRICE_CLOSE, MODE_MINUSDI, 0);
      
      panelName = preamble + "panel_M1_30_" + symbol;
      SetPanel(panelName,chartId, xOffset + stochOffset + 3 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,dbBackgroundColor, dbBorderColor, dbBorderWidth);
      labelName = preamble + "label_M1_30_" + symbol;
      
     if ((val7 > val8 ) && (dmip3 > dmim3))
      { 
        SetPanel(panelName,chartId, xOffset + stochOffset + 3 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bullColor, dbBorderColor, dbBorderWidth);
     }
      
      else if ((val7 > val8 ) && (dmip3 < dmim3) )
      {
             SetPanel(panelName,chartId, xOffset + stochOffset + 3 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bearColor, dbBorderColor, dbBorderWidth);
       }
     
      else
      {
           SetPanel(panelName,chartId, xOffset + stochOffset + 3 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,flatColor, dbBorderColor, dbBorderWidth);
      }
    
      double val9 = iADX(symbol,PERIOD_M30,144, PRICE_CLOSE, MODE_MAIN, 0);
      double val10 = iADX(symbol,PERIOD_M30,144, PRICE_CLOSE, MODE_MAIN,  1);
      double dmip4 = iADX(symbol,PERIOD_M30,144, PRICE_CLOSE, MODE_PLUSDI, 0);
      double dmim4 = iADX(symbol,PERIOD_M30,144, PRICE_CLOSE, MODE_MINUSDI, 0);
      
      panelName = preamble + "panel_M30_dds_" + symbol;
      SetPanel(panelName,chartId, xOffset + stochOffset + 4 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,dbBackgroundColor, dbBorderColor, dbBorderWidth);
      labelName = preamble + "label_M30_dds_" + symbol;
      
     if ((val9 > val10 ) && (dmip4 > dmim4))
      { 
            SetPanel(panelName,chartId, xOffset + stochOffset + 4 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bullColor, dbBorderColor, dbBorderWidth);
      }
      
      else if ((val9 > val10 ) && (dmip4 < dmim4) )
      {
        SetPanel(panelName,chartId, xOffset + stochOffset + 4 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bearColor, dbBorderColor, dbBorderWidth);
      }
        
      else
      {
           SetPanel(panelName,chartId, xOffset + stochOffset + 4 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,flatColor, dbBorderColor, dbBorderWidth);
       }
       
        ////////////************** Alert Function
           if ((val1 > val2 ) && (dmip > dmim) && (val3 > val4 ) && (dmip1 > dmim1) && (val5 > val6 ) && (dmip2 > dmim2) && (val7 > val8 ) && (dmip3 > dmim3) && (val9 > val10 ) && (dmip4 > dmim4) && (AlertTimeFrame==PERIOD_M30))
            {
            doAlert( symbol +" All ADX Lime On  " + AlertTimeFrame);
            }
      
            else if ((val1 > val2 ) && (dmip < dmim) && (val3 > val4 ) && (dmip1 < dmim1) && (val5 > val6 ) && (dmip2 < dmim2)&& (val7 > val8 ) && (dmip3 < dmim3) &&(val9 > val10 ) && (dmip4 < dmim4) && (AlertTimeFrame==PERIOD_M30) )
            {
              doAlert( symbol +" All ADX Red On  " + AlertTimeFrame);
            }
      
      //// End Alert 
    
               //************************************** end now *******************************************
     
   }
   
   if (showH1)
   {
      yOffset = yOffset + smallPanelheight + smallPanelSpace;
      SetText(chartId,preamble + "labelText_H1_1"+symbol, "      H1", xAnchor + smallPanelSpace, yOffset + textOffsetY,textColor,fontSizeText);
      
      double val1 = iADX(symbol,PERIOD_H1,7, PRICE_CLOSE, MODE_MAIN, 0);
      double val2 = iADX(symbol,PERIOD_H1,7, PRICE_CLOSE, MODE_MAIN,  1);
      double dmip = iADX(symbol,PERIOD_H1,7, PRICE_CLOSE, MODE_PLUSDI, 0);
      double dmim = iADX(symbol,PERIOD_H1,7, PRICE_CLOSE, MODE_MINUSDI, 0);
            
      panelName = preamble + "panel_H1_1_" + symbol;
      SetPanel(panelName,chartId, xOffset + stochOffset, yOffset, smallPanelWidth, smallPanelheight,dbBackgroundColor, dbBorderColor, dbBorderWidth);

      labelName = preamble + "label_H1_1_" + symbol;
    
     int fontSizeTest = 14;
     int offsetSquare = -3;
      
     if ((val1 > val2 ) && (dmip > dmim))
      { 
      SetPanel(panelName,chartId, xOffset + stochOffset, yOffset, smallPanelWidth, smallPanelheight,bullColor, dbBorderColor, dbBorderWidth);
      }
      
      else if ((val1 > val2 ) && (dmip < dmim) )
      {
              SetPanel(panelName,chartId, xOffset + stochOffset, yOffset, smallPanelWidth, smallPanelheight,bearColor, dbBorderColor, dbBorderWidth);
      }
      else
      {
         SetPanel(panelName,chartId, xOffset + stochOffset, yOffset, smallPanelWidth, smallPanelheight,flatColor, dbBorderColor, dbBorderWidth);
      }
  
     double val3 = iADX(symbol,PERIOD_H1,21, PRICE_CLOSE, MODE_MAIN, 0);
      double val4 = iADX(symbol,PERIOD_H1,21, PRICE_CLOSE, MODE_MAIN,  1);
      double dmip1 = iADX(symbol,PERIOD_H1,21, PRICE_CLOSE, MODE_PLUSDI, 0);
      double dmim1 = iADX(symbol,PERIOD_H1,21, PRICE_CLOSE, MODE_MINUSDI, 0);
      
      panelName = preamble + "panel_H1_2_" + symbol;
      SetPanel(panelName,chartId, xOffset + stochOffset + smallPanelWidth + smallPanelSpace, yOffset, smallPanelWidth, smallPanelheight,dbBackgroundColor, dbBorderColor, dbBorderWidth);
      labelName = preamble + "label_H1_2_" + symbol;
   
      if ((val3 > val4 ) && (dmip1 > dmim1))
      { 
          SetPanel(panelName,chartId, xOffset + stochOffset + smallPanelWidth + smallPanelSpace, yOffset, smallPanelWidth, smallPanelheight,bullColor, dbBorderColor, dbBorderWidth);
       }
      else if ((val3 > val4 ) && (dmip1 < dmim1) )
      {
           SetPanel(panelName,chartId, xOffset + stochOffset + smallPanelWidth + smallPanelSpace, yOffset, smallPanelWidth, smallPanelheight,bearColor, dbBorderColor, dbBorderWidth);
      }
      else
      {
           SetPanel(panelName,chartId, xOffset + stochOffset + smallPanelWidth + smallPanelSpace, yOffset, smallPanelWidth, smallPanelheight,flatColor, dbBorderColor, dbBorderWidth);
      }
      
      double val5 = iADX(symbol,PERIOD_H1,42, PRICE_CLOSE, MODE_MAIN, 0);
      double val6 = iADX(symbol,PERIOD_H1,42, PRICE_CLOSE, MODE_MAIN,  1);
      double dmip2 = iADX(symbol,PERIOD_H1,42, PRICE_CLOSE, MODE_PLUSDI, 0);
      double dmim2 = iADX(symbol,PERIOD_H1,42, PRICE_CLOSE, MODE_MINUSDI, 0);
      
      panelName = preamble + "panel_H1_3_" + symbol;
      SetPanel(panelName,chartId, xOffset + stochOffset + 2 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,dbBackgroundColor, dbBorderColor, dbBorderWidth);
      labelName = preamble + "label_H1_3_" + symbol;
    
     if ((val5 > val6 ) && (dmip2 > dmim2))
      { 
        SetPanel(panelName,chartId, xOffset + stochOffset + 2 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bullColor, dbBorderColor, dbBorderWidth);
      }
      
      else if ((val5 > val6 ) && (dmip2 < dmim2) )
      {
            SetPanel(panelName,chartId, xOffset + stochOffset + 2 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bearColor, dbBorderColor, dbBorderWidth);
      }
     
      else
      {
              SetPanel(panelName,chartId, xOffset + stochOffset + 2 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,flatColor, dbBorderColor, dbBorderWidth);
       }
      
      double val7 = iADX(symbol,PERIOD_H1,89, PRICE_CLOSE, MODE_MAIN, 0);
      double val8 = iADX(symbol,PERIOD_H1,89, PRICE_CLOSE, MODE_MAIN,  1);
      double dmip3 = iADX(symbol,PERIOD_H1,89, PRICE_CLOSE, MODE_PLUSDI, 0);
      double dmim3 = iADX(symbol,PERIOD_H1,89, PRICE_CLOSE, MODE_MINUSDI, 0);
      
      panelName = preamble + "panel_M1_H1_" + symbol;
      SetPanel(panelName,chartId, xOffset + stochOffset + 3 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,dbBackgroundColor, dbBorderColor, dbBorderWidth);
      labelName = preamble + "label_M1_H1_" + symbol;
      
     if ((val7 > val8 ) && (dmip3 > dmim3))
      { 
        SetPanel(panelName,chartId, xOffset + stochOffset + 3 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bullColor, dbBorderColor, dbBorderWidth);
     }
      
      else if ((val7 > val8 ) && (dmip3 < dmim3) )
      {
             SetPanel(panelName,chartId, xOffset + stochOffset + 3 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bearColor, dbBorderColor, dbBorderWidth);
       }
     
      else
      {
           SetPanel(panelName,chartId, xOffset + stochOffset + 3 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,flatColor, dbBorderColor, dbBorderWidth);
      }
    
      double val9 = iADX(symbol,PERIOD_H1,144, PRICE_CLOSE, MODE_MAIN, 0);
      double val10 = iADX(symbol,PERIOD_H1,144, PRICE_CLOSE, MODE_MAIN,  1);
      double dmip4 = iADX(symbol,PERIOD_H1,144, PRICE_CLOSE, MODE_PLUSDI, 0);
      double dmim4 = iADX(symbol,PERIOD_H1,144, PRICE_CLOSE, MODE_MINUSDI, 0);
      
      panelName = preamble + "panel_H1_dds_" + symbol;
      SetPanel(panelName,chartId, xOffset + stochOffset + 4 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,dbBackgroundColor, dbBorderColor, dbBorderWidth);
      labelName = preamble + "label_H1_dds_" + symbol;
      
     if ((val9 > val10 ) && (dmip4 > dmim4))
      { 
            SetPanel(panelName,chartId, xOffset + stochOffset + 4 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bullColor, dbBorderColor, dbBorderWidth);
      }
      
      else if ((val9 > val10 ) && (dmip4 < dmim4) )
      {
        SetPanel(panelName,chartId, xOffset + stochOffset + 4 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bearColor, dbBorderColor, dbBorderWidth);
      }
        
      else
      {
           SetPanel(panelName,chartId, xOffset + stochOffset + 4 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,flatColor, dbBorderColor, dbBorderWidth);
       }
    
     ////////////************** Alert Function
           if ((val1 > val2 ) && (dmip > dmim) && (val3 > val4 ) && (dmip1 > dmim1) && (val5 > val6 ) && (dmip2 > dmim2) && (val7 > val8 ) && (dmip3 > dmim3) && (val9 > val10 ) && (dmip4 > dmim4) && (AlertTimeFrame==PERIOD_H1))
            {
            doAlert( symbol +" All ADX Lime On  " + AlertTimeFrame);
            }
      
            else if ((val1 > val2 ) && (dmip < dmim) && (val3 > val4 ) && (dmip1 < dmim1) && (val5 > val6 ) && (dmip2 < dmim2)&& (val7 > val8 ) && (dmip3 < dmim3) &&(val9 > val10 ) && (dmip4 < dmim4) && (AlertTimeFrame==PERIOD_H1) )
            {
              doAlert( symbol +" All ADX Red On  " + AlertTimeFrame);
            }
      
      //// End Alert 
               //************************************** end now *******************************************
          
   }
  
   if (showH4)
   {
      yOffset = yOffset + smallPanelheight + smallPanelSpace;
      SetText(chartId,preamble + "labelText_H4_1"+symbol, "      H4", xAnchor + smallPanelSpace, yOffset + textOffsetY,textColor,fontSizeText);
      
      double val1 = iADX(symbol,PERIOD_H4,7, PRICE_CLOSE, MODE_MAIN, 0);
      double val2 = iADX(symbol,PERIOD_H4,7, PRICE_CLOSE, MODE_MAIN,  1);
      double dmip = iADX(symbol,PERIOD_H4,7, PRICE_CLOSE, MODE_PLUSDI, 0);
      double dmim = iADX(symbol,PERIOD_H4,7, PRICE_CLOSE, MODE_MINUSDI, 0);
            
      panelName = preamble + "panel_H4_1_" + symbol;
      SetPanel(panelName,chartId, xOffset + stochOffset, yOffset, smallPanelWidth, smallPanelheight,dbBackgroundColor, dbBorderColor, dbBorderWidth);

      labelName = preamble + "label_H4_1_" + symbol;
    
     int fontSizeTest = 14;
     int offsetSquare = -3;
      
     if ((val1 > val2 ) && (dmip > dmim))
      { 
      SetPanel(panelName,chartId, xOffset + stochOffset, yOffset, smallPanelWidth, smallPanelheight,bullColor, dbBorderColor, dbBorderWidth);
      }
      
      else if ((val1 > val2 ) && (dmip < dmim) )
      {
              SetPanel(panelName,chartId, xOffset + stochOffset, yOffset, smallPanelWidth, smallPanelheight,bearColor, dbBorderColor, dbBorderWidth);
      }
      else
      {
         SetPanel(panelName,chartId, xOffset + stochOffset, yOffset, smallPanelWidth, smallPanelheight,flatColor, dbBorderColor, dbBorderWidth);
      }
  
     double val3 = iADX(symbol,PERIOD_H4,21, PRICE_CLOSE, MODE_MAIN, 0);
      double val4 = iADX(symbol,PERIOD_H4,21, PRICE_CLOSE, MODE_MAIN,  1);
      double dmip1 = iADX(symbol,PERIOD_H4,21, PRICE_CLOSE, MODE_PLUSDI, 0);
      double dmim1 = iADX(symbol,PERIOD_H4,21, PRICE_CLOSE, MODE_MINUSDI, 0);
      
      panelName = preamble + "panel_H4_2_" + symbol;
      SetPanel(panelName,chartId, xOffset + stochOffset + smallPanelWidth + smallPanelSpace, yOffset, smallPanelWidth, smallPanelheight,dbBackgroundColor, dbBorderColor, dbBorderWidth);
      labelName = preamble + "label_H4_2_" + symbol;
   
      if ((val3 > val4 ) && (dmip1 > dmim1))
      { 
          SetPanel(panelName,chartId, xOffset + stochOffset + smallPanelWidth + smallPanelSpace, yOffset, smallPanelWidth, smallPanelheight,bullColor, dbBorderColor, dbBorderWidth);
       }
      else if ((val3 > val4 ) && (dmip1 < dmim1) )
      {
           SetPanel(panelName,chartId, xOffset + stochOffset + smallPanelWidth + smallPanelSpace, yOffset, smallPanelWidth, smallPanelheight,bearColor, dbBorderColor, dbBorderWidth);
      }
      else
      {
           SetPanel(panelName,chartId, xOffset + stochOffset + smallPanelWidth + smallPanelSpace, yOffset, smallPanelWidth, smallPanelheight,flatColor, dbBorderColor, dbBorderWidth);
      }
      
      double val5 = iADX(symbol,PERIOD_H4,42, PRICE_CLOSE, MODE_MAIN, 0);
      double val6 = iADX(symbol,PERIOD_H4,42, PRICE_CLOSE, MODE_MAIN,  1);
      double dmip2 = iADX(symbol,PERIOD_H4,42, PRICE_CLOSE, MODE_PLUSDI, 0);
      double dmim2 = iADX(symbol,PERIOD_H4,42, PRICE_CLOSE, MODE_MINUSDI, 0);
      
      panelName = preamble + "panel_H4_3_" + symbol;
      SetPanel(panelName,chartId, xOffset + stochOffset + 2 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,dbBackgroundColor, dbBorderColor, dbBorderWidth);
      labelName = preamble + "label_H4_3_" + symbol;
    
     if ((val5 > val6 ) && (dmip2 > dmim2))
      { 
        SetPanel(panelName,chartId, xOffset + stochOffset + 2 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bullColor, dbBorderColor, dbBorderWidth);
      }
      
      else if ((val5 > val6 ) && (dmip2 < dmim2) )
      {
            SetPanel(panelName,chartId, xOffset + stochOffset + 2 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bearColor, dbBorderColor, dbBorderWidth);
      }
     
      else
      {
              SetPanel(panelName,chartId, xOffset + stochOffset + 2 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,flatColor, dbBorderColor, dbBorderWidth);
       }
      
      double val7 = iADX(symbol,PERIOD_H4,89, PRICE_CLOSE, MODE_MAIN, 0);
      double val8 = iADX(symbol,PERIOD_H4,89, PRICE_CLOSE, MODE_MAIN,  1);
      double dmip3 = iADX(symbol,PERIOD_H4,89, PRICE_CLOSE, MODE_PLUSDI, 0);
      double dmim3 = iADX(symbol,PERIOD_H4,89, PRICE_CLOSE, MODE_MINUSDI, 0);
      
      panelName = preamble + "panel_M1_H4_" + symbol;
      SetPanel(panelName,chartId, xOffset + stochOffset + 3 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,dbBackgroundColor, dbBorderColor, dbBorderWidth);
      labelName = preamble + "label_M1_H4_" + symbol;
      
     if ((val7 > val8 ) && (dmip3 > dmim3))
      { 
        SetPanel(panelName,chartId, xOffset + stochOffset + 3 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bullColor, dbBorderColor, dbBorderWidth);
     }
      
      else if ((val7 > val8 ) && (dmip3 < dmim3) )
      {
             SetPanel(panelName,chartId, xOffset + stochOffset + 3 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bearColor, dbBorderColor, dbBorderWidth);
       }
     
      else
      {
           SetPanel(panelName,chartId, xOffset + stochOffset + 3 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,flatColor, dbBorderColor, dbBorderWidth);
      }
    
      double val9 = iADX(symbol,PERIOD_H4,144, PRICE_CLOSE, MODE_MAIN, 0);
      double val10 = iADX(symbol,PERIOD_H4,144, PRICE_CLOSE, MODE_MAIN,  1);
      double dmip4 = iADX(symbol,PERIOD_H4,144, PRICE_CLOSE, MODE_PLUSDI, 0);
      double dmim4 = iADX(symbol,PERIOD_H4,144, PRICE_CLOSE, MODE_MINUSDI, 0);
      
      panelName = preamble + "panel_H4_dds_" + symbol;
      SetPanel(panelName,chartId, xOffset + stochOffset + 4 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,dbBackgroundColor, dbBorderColor, dbBorderWidth);
      labelName = preamble + "label_H4_dds_" + symbol;
      
     if ((val9 > val10 ) && (dmip4 > dmim4))
      { 
            SetPanel(panelName,chartId, xOffset + stochOffset + 4 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bullColor, dbBorderColor, dbBorderWidth);
      }
      
      else if ((val9 > val10 ) && (dmip4 < dmim4) )
      {
        SetPanel(panelName,chartId, xOffset + stochOffset + 4 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bearColor, dbBorderColor, dbBorderWidth);
      }
        
      else
      {
           SetPanel(panelName,chartId, xOffset + stochOffset + 4 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,flatColor, dbBorderColor, dbBorderWidth);
       }
       
        ////////////************** Alert Function
           if ((val1 > val2 ) && (dmip > dmim) && (val3 > val4 ) && (dmip1 > dmim1) && (val5 > val6 ) && (dmip2 > dmim2) && (val7 > val8 ) && (dmip3 > dmim3) && (val9 > val10 ) && (dmip4 > dmim4) && (AlertTimeFrame==PERIOD_H4))
            {
            doAlert( symbol +" All ADX Lime On  " + AlertTimeFrame);
            }
      
            else if ((val1 > val2 ) && (dmip < dmim) && (val3 > val4 ) && (dmip1 < dmim1) && (val5 > val6 ) && (dmip2 < dmim2)&& (val7 > val8 ) && (dmip3 < dmim3) &&(val9 > val10 ) && (dmip4 < dmim4) && (AlertTimeFrame==PERIOD_H4) )
            {
              doAlert( symbol +" All ADX Red On  " + AlertTimeFrame);
            }
      
      //// End Alert 
    
               //************************************** end now *******************************************
             
   }
  
   if (showDay)
   {
      yOffset = yOffset + smallPanelheight + smallPanelSpace;
      SetText(chartId,preamble + "labelText_D1_1"+symbol, "      D1", xAnchor + smallPanelSpace, yOffset + textOffsetY,textColor,fontSizeText);
      
      double val1 = iADX(symbol,PERIOD_D1,7, PRICE_CLOSE, MODE_MAIN, 0);
      double val2 = iADX(symbol,PERIOD_D1,7, PRICE_CLOSE, MODE_MAIN,  1);
      double dmip = iADX(symbol,PERIOD_D1,7, PRICE_CLOSE, MODE_PLUSDI, 0);
      double dmim = iADX(symbol,PERIOD_D1,7, PRICE_CLOSE, MODE_MINUSDI, 0);
            
      panelName = preamble + "panel_D1_1_" + symbol;
      SetPanel(panelName,chartId, xOffset + stochOffset, yOffset, smallPanelWidth, smallPanelheight,dbBackgroundColor, dbBorderColor, dbBorderWidth);

      labelName = preamble + "label_D1_1_" + symbol;
    
     int fontSizeTest = 14;
     int offsetSquare = -3;
      
     if ((val1 > val2 ) && (dmip > dmim))
      { 
      SetPanel(panelName,chartId, xOffset + stochOffset, yOffset, smallPanelWidth, smallPanelheight,bullColor, dbBorderColor, dbBorderWidth);
      }
      
      else if ((val1 > val2 ) && (dmip < dmim) )
      {
              SetPanel(panelName,chartId, xOffset + stochOffset, yOffset, smallPanelWidth, smallPanelheight,bearColor, dbBorderColor, dbBorderWidth);
      }
      else
      {
         SetPanel(panelName,chartId, xOffset + stochOffset, yOffset, smallPanelWidth, smallPanelheight,flatColor, dbBorderColor, dbBorderWidth);
      }
  
     double val3 = iADX(symbol,PERIOD_D1,21, PRICE_CLOSE, MODE_MAIN, 0);
      double val4 = iADX(symbol,PERIOD_D1,21, PRICE_CLOSE, MODE_MAIN,  1);
      double dmip1 = iADX(symbol,PERIOD_D1,21, PRICE_CLOSE, MODE_PLUSDI, 0);
      double dmim1 = iADX(symbol,PERIOD_D1,21, PRICE_CLOSE, MODE_MINUSDI, 0);
      
      panelName = preamble + "panel_D1_2_" + symbol;
      SetPanel(panelName,chartId, xOffset + stochOffset + smallPanelWidth + smallPanelSpace, yOffset, smallPanelWidth, smallPanelheight,dbBackgroundColor, dbBorderColor, dbBorderWidth);
      labelName = preamble + "label_D1_2_" + symbol;
   
      if ((val3 > val4 ) && (dmip1 > dmim1))
      { 
          SetPanel(panelName,chartId, xOffset + stochOffset + smallPanelWidth + smallPanelSpace, yOffset, smallPanelWidth, smallPanelheight,bullColor, dbBorderColor, dbBorderWidth);
       }
      else if ((val3 > val4 ) && (dmip1 < dmim1) )
      {
           SetPanel(panelName,chartId, xOffset + stochOffset + smallPanelWidth + smallPanelSpace, yOffset, smallPanelWidth, smallPanelheight,bearColor, dbBorderColor, dbBorderWidth);
      }
      else
      {
           SetPanel(panelName,chartId, xOffset + stochOffset + smallPanelWidth + smallPanelSpace, yOffset, smallPanelWidth, smallPanelheight,flatColor, dbBorderColor, dbBorderWidth);
      }
      
      double val5 = iADX(symbol,PERIOD_D1,42, PRICE_CLOSE, MODE_MAIN, 0);
      double val6 = iADX(symbol,PERIOD_D1,42, PRICE_CLOSE, MODE_MAIN,  1);
      double dmip2 = iADX(symbol,PERIOD_D1,42, PRICE_CLOSE, MODE_PLUSDI, 0);
      double dmim2 = iADX(symbol,PERIOD_D1,42, PRICE_CLOSE, MODE_MINUSDI, 0);
      
      panelName = preamble + "panel_D1_3_" + symbol;
      SetPanel(panelName,chartId, xOffset + stochOffset + 2 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,dbBackgroundColor, dbBorderColor, dbBorderWidth);
      labelName = preamble + "label_D1_3_" + symbol;
    
     if ((val5 > val6 ) && (dmip2 > dmim2))
      { 
        SetPanel(panelName,chartId, xOffset + stochOffset + 2 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bullColor, dbBorderColor, dbBorderWidth);
      }
      
      else if ((val5 > val6 ) && (dmip2 < dmim2) )
      {
            SetPanel(panelName,chartId, xOffset + stochOffset + 2 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bearColor, dbBorderColor, dbBorderWidth);
      }
     
      else
      {
              SetPanel(panelName,chartId, xOffset + stochOffset + 2 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,flatColor, dbBorderColor, dbBorderWidth);
       }
      
      double val7 = iADX(symbol,PERIOD_D1,89, PRICE_CLOSE, MODE_MAIN, 0);
      double val8 = iADX(symbol,PERIOD_D1,89, PRICE_CLOSE, MODE_MAIN,  1);
      double dmip3 = iADX(symbol,PERIOD_D1,89, PRICE_CLOSE, MODE_PLUSDI, 0);
      double dmim3 = iADX(symbol,PERIOD_D1,89, PRICE_CLOSE, MODE_MINUSDI, 0);
      
      panelName = preamble + "panel_M1_D1_" + symbol;
      SetPanel(panelName,chartId, xOffset + stochOffset + 3 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,dbBackgroundColor, dbBorderColor, dbBorderWidth);
      labelName = preamble + "label_M1_D1_" + symbol;
      
     if ((val7 > val8 ) && (dmip3 > dmim3))
      { 
        SetPanel(panelName,chartId, xOffset + stochOffset + 3 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bullColor, dbBorderColor, dbBorderWidth);
     }
      
      else if ((val7 > val8 ) && (dmip3 < dmim3) )
      {
             SetPanel(panelName,chartId, xOffset + stochOffset + 3 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bearColor, dbBorderColor, dbBorderWidth);
       }
     
      else
      {
           SetPanel(panelName,chartId, xOffset + stochOffset + 3 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,flatColor, dbBorderColor, dbBorderWidth);
      }
    
      double val9 = iADX(symbol,PERIOD_D1,144, PRICE_CLOSE, MODE_MAIN, 0);
      double val10 = iADX(symbol,PERIOD_D1,144, PRICE_CLOSE, MODE_MAIN,  1);
      double dmip4 = iADX(symbol,PERIOD_D1,144, PRICE_CLOSE, MODE_PLUSDI, 0);
      double dmim4 = iADX(symbol,PERIOD_D1,144, PRICE_CLOSE, MODE_MINUSDI, 0);
      
      panelName = preamble + "panel_D1_dds_" + symbol;
      SetPanel(panelName,chartId, xOffset + stochOffset + 4 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,dbBackgroundColor, dbBorderColor, dbBorderWidth);
      labelName = preamble + "label_D1_dds_" + symbol;
      
     if ((val9 > val10 ) && (dmip4 > dmim4))
      { 
            SetPanel(panelName,chartId, xOffset + stochOffset + 4 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bullColor, dbBorderColor, dbBorderWidth);
      }
      
      else if ((val9 > val10 ) && (dmip4 < dmim4) )
      {
        SetPanel(panelName,chartId, xOffset + stochOffset + 4 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bearColor, dbBorderColor, dbBorderWidth);
      }
        
      else
      {
           SetPanel(panelName,chartId, xOffset + stochOffset + 4 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,flatColor, dbBorderColor, dbBorderWidth);
       }
        ////////////************** Alert Function
           if ((val1 > val2 ) && (dmip > dmim) && (val3 > val4 ) && (dmip1 > dmim1) && (val5 > val6 ) && (dmip2 > dmim2) && (val7 > val8 ) && (dmip3 > dmim3) && (val9 > val10 ) && (dmip4 > dmim4) && (AlertTimeFrame==PERIOD_D1))
            {
            doAlert( symbol +" All ADX Lime On  " + AlertTimeFrame);
            }
      
            else if ((val1 > val2 ) && (dmip < dmim) && (val3 > val4 ) && (dmip1 < dmim1) && (val5 > val6 ) && (dmip2 < dmim2)&& (val7 > val8 ) && (dmip3 < dmim3) &&(val9 > val10 ) && (dmip4 < dmim4) && (AlertTimeFrame==PERIOD_D1) )
            {
              doAlert( symbol +" All ADX Red On  " + AlertTimeFrame);
            }
      
      //// End Alert 
    
               //************************************** end now *******************************************
          
   }
 
   
   if (showWeek)
   {
   yOffset = yOffset + smallPanelheight + smallPanelSpace;
      SetText(chartId,preamble + "labelText_W1_1"+symbol, "      W", xAnchor + smallPanelSpace, yOffset + textOffsetY,textColor,fontSizeText);
      
      double val1 = iADX(symbol,PERIOD_W1,7, PRICE_CLOSE, MODE_MAIN, 0);
      double val2 = iADX(symbol,PERIOD_W1,7, PRICE_CLOSE, MODE_MAIN,  1);
      double dmip = iADX(symbol,PERIOD_W1,7, PRICE_CLOSE, MODE_PLUSDI, 0);
      double dmim = iADX(symbol,PERIOD_W1,7, PRICE_CLOSE, MODE_MINUSDI, 0);
            
      panelName = preamble + "panel_W1_1_" + symbol;
      SetPanel(panelName,chartId, xOffset + stochOffset, yOffset, smallPanelWidth, smallPanelheight,dbBackgroundColor, dbBorderColor, dbBorderWidth);

      labelName = preamble + "label_W1_1_" + symbol;
    
     int fontSizeTest = 14;
     int offsetSquare = -3;
      
     if ((val1 > val2 ) && (dmip > dmim))
      { 
      SetPanel(panelName,chartId, xOffset + stochOffset, yOffset, smallPanelWidth, smallPanelheight,bullColor, dbBorderColor, dbBorderWidth);
      }
      
      else if ((val1 > val2 ) && (dmip < dmim) )
      {
              SetPanel(panelName,chartId, xOffset + stochOffset, yOffset, smallPanelWidth, smallPanelheight,bearColor, dbBorderColor, dbBorderWidth);
      }
      else
      {
         SetPanel(panelName,chartId, xOffset + stochOffset, yOffset, smallPanelWidth, smallPanelheight,flatColor, dbBorderColor, dbBorderWidth);
      }
  
     double val3 = iADX(symbol,PERIOD_W1,21, PRICE_CLOSE, MODE_MAIN, 0);
      double val4 = iADX(symbol,PERIOD_W1,21, PRICE_CLOSE, MODE_MAIN,  1);
      double dmip1 = iADX(symbol,PERIOD_W1,21, PRICE_CLOSE, MODE_PLUSDI, 0);
      double dmim1 = iADX(symbol,PERIOD_W1,21, PRICE_CLOSE, MODE_MINUSDI, 0);
      
      panelName = preamble + "panel_W1_2_" + symbol;
      SetPanel(panelName,chartId, xOffset + stochOffset + smallPanelWidth + smallPanelSpace, yOffset, smallPanelWidth, smallPanelheight,dbBackgroundColor, dbBorderColor, dbBorderWidth);
      labelName = preamble + "label_W1_2_" + symbol;
   
      if ((val3 > val4 ) && (dmip1 > dmim1))
      { 
          SetPanel(panelName,chartId, xOffset + stochOffset + smallPanelWidth + smallPanelSpace, yOffset, smallPanelWidth, smallPanelheight,bullColor, dbBorderColor, dbBorderWidth);
       }
      else if ((val3 > val4 ) && (dmip1 < dmim1) )
      {
           SetPanel(panelName,chartId, xOffset + stochOffset + smallPanelWidth + smallPanelSpace, yOffset, smallPanelWidth, smallPanelheight,bearColor, dbBorderColor, dbBorderWidth);
      }
      else
      {
           SetPanel(panelName,chartId, xOffset + stochOffset + smallPanelWidth + smallPanelSpace, yOffset, smallPanelWidth, smallPanelheight,flatColor, dbBorderColor, dbBorderWidth);
      }
      
      double val5 = iADX(symbol,PERIOD_W1,42, PRICE_CLOSE, MODE_MAIN, 0);
      double val6 = iADX(symbol,PERIOD_W1,42, PRICE_CLOSE, MODE_MAIN,  1);
      double dmip2 = iADX(symbol,PERIOD_W1,42, PRICE_CLOSE, MODE_PLUSDI, 0);
      double dmim2 = iADX(symbol,PERIOD_W1,42, PRICE_CLOSE, MODE_MINUSDI, 0);
      
      panelName = preamble + "panel_W1_3_" + symbol;
      SetPanel(panelName,chartId, xOffset + stochOffset + 2 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,dbBackgroundColor, dbBorderColor, dbBorderWidth);
      labelName = preamble + "label_W1_3_" + symbol;
    
     if ((val5 > val6 ) && (dmip2 > dmim2))
      { 
        SetPanel(panelName,chartId, xOffset + stochOffset + 2 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bullColor, dbBorderColor, dbBorderWidth);
      }
      
      else if ((val5 > val6 ) && (dmip2 < dmim2) )
      {
            SetPanel(panelName,chartId, xOffset + stochOffset + 2 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bearColor, dbBorderColor, dbBorderWidth);
      }
     
      else
      {
              SetPanel(panelName,chartId, xOffset + stochOffset + 2 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,flatColor, dbBorderColor, dbBorderWidth);
       }
      
      double val7 = iADX(symbol,PERIOD_W1,89, PRICE_CLOSE, MODE_MAIN, 0);
      double val8 = iADX(symbol,PERIOD_W1,89, PRICE_CLOSE, MODE_MAIN,  1);
      double dmip3 = iADX(symbol,PERIOD_W1,89, PRICE_CLOSE, MODE_PLUSDI, 0);
      double dmim3 = iADX(symbol,PERIOD_W1,89, PRICE_CLOSE, MODE_MINUSDI, 0);
      
      panelName = preamble + "panel_M1_W1_" + symbol;
      SetPanel(panelName,chartId, xOffset + stochOffset + 3 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,dbBackgroundColor, dbBorderColor, dbBorderWidth);
      labelName = preamble + "label_M1_W1_" + symbol;
      
     if ((val7 > val8 ) && (dmip3 > dmim3))
      { 
        SetPanel(panelName,chartId, xOffset + stochOffset + 3 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bullColor, dbBorderColor, dbBorderWidth);
     }
      
      else if ((val7 > val8 ) && (dmip3 < dmim3) )
      {
             SetPanel(panelName,chartId, xOffset + stochOffset + 3 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bearColor, dbBorderColor, dbBorderWidth);
       }
     
      else
      {
           SetPanel(panelName,chartId, xOffset + stochOffset + 3 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,flatColor, dbBorderColor, dbBorderWidth);
      }
    
      double val9 = iADX(symbol,PERIOD_W1,144, PRICE_CLOSE, MODE_MAIN, 0);
      double val10 = iADX(symbol,PERIOD_W1,144, PRICE_CLOSE, MODE_MAIN,  1);
      double dmip4 = iADX(symbol,PERIOD_W1,144, PRICE_CLOSE, MODE_PLUSDI, 0);
      double dmim4 = iADX(symbol,PERIOD_W1,144, PRICE_CLOSE, MODE_MINUSDI, 0);
      
      panelName = preamble + "panel_W1_dds_" + symbol;
      SetPanel(panelName,chartId, xOffset + stochOffset + 4 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,dbBackgroundColor, dbBorderColor, dbBorderWidth);
      labelName = preamble + "label_W1_dds_" + symbol;
      
     if ((val9 > val10 ) && (dmip4 > dmim4))
      { 
            SetPanel(panelName,chartId, xOffset + stochOffset + 4 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bullColor, dbBorderColor, dbBorderWidth);
      }
      
      else if ((val9 > val10 ) && (dmip4 < dmim4) )
      {
        SetPanel(panelName,chartId, xOffset + stochOffset + 4 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,bearColor, dbBorderColor, dbBorderWidth);
      }
        
      else
      {
           SetPanel(panelName,chartId, xOffset + stochOffset + 4 * (smallPanelWidth + smallPanelSpace), yOffset, smallPanelWidth, smallPanelheight,flatColor, dbBorderColor, dbBorderWidth);
       }
    
     ////////////************** Alert Function
           if ((val1 > val2 ) && (dmip > dmim) && (val3 > val4 ) && (dmip1 > dmim1) && (val5 > val6 ) && (dmip2 > dmim2) && (val7 > val8 ) && (dmip3 > dmim3) && (val9 > val10 ) && (dmip4 > dmim4) && (AlertTimeFrame==PERIOD_W1))
            {
            doAlert( symbol +" All ADX Lime On  " + AlertTimeFrame);
            }
      
            else if ((val1 > val2 ) && (dmip < dmim) && (val3 > val4 ) && (dmip1 < dmim1) && (val5 > val6 ) && (dmip2 < dmim2)&& (val7 > val8 ) && (dmip3 < dmim3) &&(val9 > val10 ) && (dmip4 < dmim4) && (AlertTimeFrame==PERIOD_W1) )
            {
              doAlert( symbol +" All ADX Red On  " + AlertTimeFrame);
            }
      
      //// End Alert 
               //************************************** end now *******************************************
                 
   }
     
}
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//---
   
  }
//+------------------------------------------------------------------+


void SetObjText(long chart_id, string name,string CharToStr,int x,int y,color colour,int fontsize=12)
  {
   if(ObjectFind(0,name)<0)
      ObjectCreate(0, name, OBJ_LABEL,chart_id, 0, 0);
   ObjectSetInteger(0,name,OBJPROP_FONTSIZE,fontsize);
   ObjectSetInteger(0,name,OBJPROP_COLOR,colour);
   ObjectSetInteger(0,name,OBJPROP_BACK,false);
   ObjectSetInteger(0,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y);
   ObjectSetString(0,name,OBJPROP_TEXT,CharToStr);
   ObjectSetString(0,name,OBJPROP_FONT,"Wingdings");
  }
  
  void SetText(long chart_id, string name,string text,int x,int y,color colour,int fontsize)
  {
   if (ObjectFind(0,name)<0)
      ObjectCreate(0,name,OBJ_LABEL,chart_id,0,0);
    ObjectSetInteger(0,name,OBJPROP_XDISTANCE,x);
    ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y);
    ObjectSetInteger(0,name,OBJPROP_COLOR,colour);
    ObjectSetInteger(0,name,OBJPROP_FONTSIZE,fontsize);
    ObjectSetInteger(0,name,OBJPROP_CORNER,CORNER_LEFT_UPPER);
    ObjectSetString(0,name,OBJPROP_FONT,"Arial");
    ObjectSetString(0,name,OBJPROP_TEXT,text);
  }
  
void SetPanel(string name,int chart_id,int x,int y,int width,int height,color bg_color,color border_clr,int border_width)
  {
   if (ObjectFind(0, name) < 0) ObjectCreate(0,name,OBJ_RECTANGLE_LABEL,chart_id,0,0);
      ObjectSetInteger(0,name,OBJPROP_XDISTANCE,x);
      ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y);
      ObjectSetInteger(0,name,OBJPROP_XSIZE,width);
      ObjectSetInteger(0,name,OBJPROP_YSIZE,height);
      ObjectSetInteger(0,name,OBJPROP_COLOR,border_clr);
      ObjectSetInteger(0,name,OBJPROP_BORDER_TYPE,BORDER_FLAT);
      ObjectSetInteger(0,name,OBJPROP_WIDTH,border_width);
      ObjectSetInteger(0,name,OBJPROP_CORNER,CORNER_LEFT_UPPER);
      ObjectSetInteger(0,name,OBJPROP_STYLE,STYLE_SOLID);
      ObjectSetInteger(0,name,OBJPROP_BACK,true);
      ObjectSetInteger(0,name,OBJPROP_SELECTABLE,false);
      ObjectSetInteger(0,name,OBJPROP_SELECTED,false);
      ObjectSetInteger(0,name,OBJPROP_HIDDEN,true);
      ObjectSetInteger(0,name,OBJPROP_ZORDER,0);
      ObjectSetInteger(0,name,OBJPROP_BGCOLOR,bg_color);
  }
  
void Create_Button(string but_name,string label,int xsize,int ysize,int xdist,int ydist,int bcolor,int fcolor)
{
   if(ObjectFind(0,but_name)<0)
   {
      if(!ObjectCreate(0,but_name,OBJ_BUTTON,0,0,0))
        {
         Print(__FUNCTION__,
               ": failed to create the button! Error code = ",GetLastError());
         return;
        }
      ObjectSetString(0,but_name,OBJPROP_TEXT,label);
      ObjectSetInteger(0,but_name,OBJPROP_XSIZE,xsize);
      ObjectSetInteger(0,but_name,OBJPROP_YSIZE,ysize);
      ObjectSetInteger(0,but_name,OBJPROP_CORNER,CORNER_LEFT_UPPER);     
      ObjectSetInteger(0,but_name,OBJPROP_XDISTANCE,xdist);      
      ObjectSetInteger(0,but_name,OBJPROP_YDISTANCE,ydist);         
      ObjectSetInteger(0,but_name,OBJPROP_BGCOLOR,bcolor);
      ObjectSetInteger(0,but_name,OBJPROP_COLOR,fcolor);
      ObjectSetInteger(0,but_name,OBJPROP_FONTSIZE,8);
      ObjectSetInteger(0,but_name,OBJPROP_HIDDEN,true);
      ObjectSetInteger(0,but_name,OBJPROP_SELECTABLE,true);
      //ObjectSetInteger(0,but_name,OBJPROP_BORDER_COLOR,ChartGetInteger(0,CHART_COLOR_FOREGROUND));
      ObjectSetInteger(0,but_name,OBJPROP_BORDER_TYPE,BORDER_RAISED);
      ChartRedraw();      
   }
}


double TLBMax_M01[];
double TLBMax_M05[];
double TLBMax_M15[];
double TLBMax_M30[];
double TLBMax_H01[];
double TLBMax_H04[];
double TLBMax_D01[];
double TLBMax_W01[];
double TLBMax_MN1[];

double TLBMin_M01[];
double TLBMin_M05[];
double TLBMin_M15[];
double TLBMin_M30[];
double TLBMin_H01[];
double TLBMin_H04[];
double TLBMin_D01[];
double TLBMin_W01[];
double TLBMin_MN1[];

static datetime prevBarCount_M01 = NULL;  
static datetime prevBarCount_M05 = NULL;  
static datetime prevBarCount_M15 = NULL;  
static datetime prevBarCount_M30 = NULL;  
static datetime prevBarCount_H01 = NULL;  
static datetime prevBarCount_H04 = NULL;  
static datetime prevBarCount_D01 = NULL;  
static datetime prevBarCount_W01 = NULL;  
static datetime prevBarCount_MN1 = NULL; 

static datetime prevBarTime_M01 = NULL;  
static datetime prevBarTime_M05 = NULL;  
static datetime prevBarTime_M15 = NULL;  
static datetime prevBarTime_M30 = NULL;  
static datetime prevBarTime_H01 = NULL;  
static datetime prevBarTime_H04 = NULL;  
static datetime prevBarTime_D01 = NULL;  
static datetime prevBarTime_W01 = NULL;  
static datetime prevBarTime_MN1 = NULL;

void set_prevBarTime( int mt4Period, datetime value )
{
 switch( mt4Period )
 {
  case PERIOD_M1:  { prevBarTime_M01 = value; break; }
  case PERIOD_M5:  { prevBarTime_M05 = value; break; }
  case PERIOD_M15: { prevBarTime_M15 = value; break; }
  case PERIOD_M30: { prevBarTime_M30 = value; break; }
  case PERIOD_H1:  { prevBarTime_H01 = value; break; }
  case PERIOD_H4:  { prevBarTime_H04 = value; break; }
  case PERIOD_D1:  { prevBarTime_D01 = value; break; }
  case PERIOD_W1:  { prevBarTime_W01 = value; break; }
  case PERIOD_MN1: { prevBarTime_MN1 = value; break; } 
 }
}

datetime get_prevBarTime( int mt4Period )
{
 switch( mt4Period )
 {
  case PERIOD_M1:  { return (prevBarTime_M01); break; }
  case PERIOD_M5:  { return (prevBarTime_M05); break; }
  case PERIOD_M15: { return (prevBarTime_M15); break; }
  case PERIOD_M30: { return (prevBarTime_M30); break; }
  case PERIOD_H1:  { return (prevBarTime_H01); break; }
  case PERIOD_H4:  { return (prevBarTime_H04); break; }
  case PERIOD_D1:  { return (prevBarTime_D01); break; }
  case PERIOD_W1:  { return (prevBarTime_W01); break; }
  case PERIOD_MN1: { return (prevBarTime_MN1); break; } 
 }
 
 return 0;
}
    
void set_prevBarCount( int mt4Period, int value )
{
 switch( mt4Period )
 {
  case PERIOD_M1:  { prevBarCount_M01 = value; break; }
  case PERIOD_M5:  { prevBarCount_M05 = value; break; }
  case PERIOD_M15: { prevBarCount_M15 = value; break; }
  case PERIOD_M30: { prevBarCount_M30 = value; break; }
  case PERIOD_H1:  { prevBarCount_H01 = value; break; }
  case PERIOD_H4:  { prevBarCount_H04 = value; break; }
  case PERIOD_D1:  { prevBarCount_D01 = value; break; }
  case PERIOD_W1:  { prevBarCount_W01 = value; break; }
  case PERIOD_MN1: { prevBarCount_MN1 = value; break; } 
 }
}

int get_prevBarCount( int mt4Period )
{
 switch( mt4Period )
 {
  case PERIOD_M1:  { return (prevBarCount_M01); break; }
  case PERIOD_M5:  { return (prevBarCount_M05); break; }
  case PERIOD_M15: { return (prevBarCount_M15); break; }
  case PERIOD_M30: { return (prevBarCount_M30); break; }
  case PERIOD_H1:  { return (prevBarCount_H01); break; }
  case PERIOD_H4:  { return (prevBarCount_H04); break; }
  case PERIOD_D1:  { return (prevBarCount_D01); break; }
  case PERIOD_W1:  { return (prevBarCount_W01); break; }
  case PERIOD_MN1: { return (prevBarCount_MN1); break; } 
 }
 
 return -1;
}

void set_max( int mt4Period, int shift, double value )
{
 switch( mt4Period )
 {
  case PERIOD_M1:  { TLBMax_M01[ shift ] = value; break; }
  case PERIOD_M5:  { TLBMax_M05[ shift ] = value; break; }
  case PERIOD_M15: { TLBMax_M15[ shift ] = value; break; }
  case PERIOD_M30: { TLBMax_M30[ shift ] = value; break; }
  case PERIOD_H1:  { TLBMax_H01[ shift ] = value; break; }
  case PERIOD_H4:  { TLBMax_H04[ shift ] = value; break; }
  case PERIOD_D1:  { TLBMax_D01[ shift ] = value; break; }
  case PERIOD_W1:  { TLBMax_W01[ shift ] = value; break; }
  case PERIOD_MN1: { TLBMax_MN1[ shift ] = value; break; }
 }
}

double get_max( int mt4Period, int shift )
{
 switch( mt4Period )
 {
  case PERIOD_M1:  { return(TLBMax_M01[ shift ]); break; }
  case PERIOD_M5:  { return(TLBMax_M05[ shift ]); break; }
  case PERIOD_M15: { return(TLBMax_M15[ shift ]); break; }
  case PERIOD_M30: { return(TLBMax_M30[ shift ]); break; }
  case PERIOD_H1:  { return(TLBMax_H01[ shift ]); break; }
  case PERIOD_H4:  { return(TLBMax_H04[ shift ]); break; }
  case PERIOD_D1:  { return(TLBMax_D01[ shift ]); break; }
  case PERIOD_W1:  { return(TLBMax_W01[ shift ]); break; }
  case PERIOD_MN1: { return(TLBMax_MN1[ shift ]); break; }
 }
 return -1.0;
}
void set_min( int mt4Period, int shift, double value )
{
 switch( mt4Period )
 {
  case PERIOD_M1:  { TLBMin_M01[ shift ] = value; break; }
  case PERIOD_M5:  { TLBMin_M05[ shift ] = value; break; }
  case PERIOD_M15: { TLBMin_M15[ shift ] = value; break; }
  case PERIOD_M30: { TLBMin_M30[ shift ] = value; break; }
  case PERIOD_H1:  { TLBMin_H01[ shift ] = value; break; }
  case PERIOD_H4:  { TLBMin_H04[ shift ] = value; break; }
  case PERIOD_D1:  { TLBMin_D01[ shift ] = value; break; }
  case PERIOD_W1:  { TLBMin_W01[ shift ] = value; break; }
  case PERIOD_MN1: { TLBMin_MN1[ shift ] = value; break; }
 }
}

double get_min( int mt4Period, int shift )
{
 switch( mt4Period )
 {
  case PERIOD_M1:  { return(TLBMin_M01[ shift ]); break; }
  case PERIOD_M5:  { return(TLBMin_M05[ shift ]); break; }
  case PERIOD_M15: { return(TLBMin_M15[ shift ]); break; }
  case PERIOD_M30: { return(TLBMin_M30[ shift ]); break; }
  case PERIOD_H1:  { return(TLBMin_H01[ shift ]); break; }
  case PERIOD_H4:  { return(TLBMin_H04[ shift ]); break; }
  case PERIOD_D1:  { return(TLBMin_D01[ shift ]); break; }
  case PERIOD_W1:  { return(TLBMin_W01[ shift ]); break; }
  case PERIOD_MN1: { return(TLBMin_MN1[ shift ]); break; }
 }
 return -1.0;
}

void emulate_tlbmaxmin( int mt4Period, int numBars )
{
 switch( mt4Period )
 {
  case PERIOD_M1:  { EmulateDoubleBuffer(TLBMax_M01, numBars ); EmulateDoubleBuffer(TLBMin_M01, numBars ); break; }
  case PERIOD_M5:  { EmulateDoubleBuffer(TLBMax_M05, numBars ); EmulateDoubleBuffer(TLBMin_M05, numBars ); break; }
  case PERIOD_M15: { EmulateDoubleBuffer(TLBMax_M15, numBars ); EmulateDoubleBuffer(TLBMin_M15, numBars ); break; }
  case PERIOD_M30: { EmulateDoubleBuffer(TLBMax_M30, numBars ); EmulateDoubleBuffer(TLBMin_M30, numBars ); break; }
  case PERIOD_H1:  { EmulateDoubleBuffer(TLBMax_H01, numBars ); EmulateDoubleBuffer(TLBMin_H01, numBars ); break; }
  case PERIOD_H4:  { EmulateDoubleBuffer(TLBMax_H04, numBars ); EmulateDoubleBuffer(TLBMin_H04, numBars ); break; }
  case PERIOD_D1:  { EmulateDoubleBuffer(TLBMax_D01, numBars ); EmulateDoubleBuffer(TLBMin_D01, numBars ); break; }
  case PERIOD_W1:  { EmulateDoubleBuffer(TLBMax_W01, numBars ); EmulateDoubleBuffer(TLBMin_W01, numBars ); break; }
  case PERIOD_MN1: { EmulateDoubleBuffer(TLBMax_MN1, numBars ); EmulateDoubleBuffer(TLBMin_MN1, numBars ); break; }
 }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double Diap( int mt4Period, bool up, int C, int shift )
  { 
   int i;
   double MM;
   if(up)
     {
       MM = get_max( mt4Period, shift );
       for(i = 1; i < C; i++)
           if(get_max( mt4Period, shift-i ) > MM)
               MM = get_max( mt4Period, shift-i );  
     }
   if(!up)
     {
       MM = get_min( mt4Period, shift );
       for(i = 1; i < C; i++)
           if(get_min( mt4Period, shift-i ) < MM)
               MM = get_min( mt4Period, shift-i );  
     }  
  return(MM);
  }
  
  
void EmulateDoubleBuffer( double &buffer[], int numBars )
{
   //---- INDICATOR BUFFERS EMULATION
   if(ArraySize(buffer) < numBars)
     {
       ArraySetAsSeries(buffer, false);
       //----  
       ArrayResize(buffer, numBars); 
       //----
       ArraySetAsSeries(buffer, true);
     } 
}  

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          message =  StringConcatenate(doWhat+ " Time Frame ");
              Alert(message);
          
      }
}